package model;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.UUID;

/**
 * This file is part of PA165 school project.
 */
public class Order {
    private final int price;
    private final UUID id;
    private List<Runnable> completed = new ArrayList<>();

    public Order(int price) {
        this.price = price;
        this.id = UUID.randomUUID();
    }

    public void addCompleted(Runnable r) {
        this.completed.add(r);
    }

    void fireCompletedEvent() {
        completed.forEach((Runnable r) -> {
            try{
                r.run();
            } catch (Exception e) {
                e.printStackTrace();;
            }
        });
    }

    public UUID getId() {
        return id;
    }

    public int getPrice() {
        return price;
    }

}
