package model.dealers;

import model.Exchange;
import model.Order;

/**
 * This file is part of PA165 school project.
 */
public class SimpleDealer extends Thread implements Dealer {

    private Exchange exchange;

    private int delta;
    private SimpleBuyerAction action;

    Order lastOrder = null;

    public SimpleDealer(Exchange exchange, int delta, SimpleBuyerAction action)
    {
        this.delta = delta;
        this.action = action;
        this.exchange = exchange;
    }

    @Override
    public void run() {
        do{
            if(lastOrder != null) {
//                if(Math.random() < 0.2) {
                    exchange.cancelOrder(lastOrder);
//                } else {
//                    sleep(1000);
//                    continue;
//                }
            }

            // todo: cancel orders after ten ticks or so
            lastOrder = action.doAction(
                exchange,
                delta
            );

            sleep(1000);
        } while (true);
    }

    private void sleep(int millis) {
        try {
            Thread.sleep(millis);
        } catch (InterruptedException e) {
            System.out.println("Thread interrupted.");
        }
    }
}
